tabletPdaDefaultSide1 = {};

function tabletPdaDefaultSide1:generate(installModGuiTablePos, whichPDA, masterPage, slavePage, pageSide)
	----is line/button a pullDownMenue ---> check is pullDownOpen or not --> g_currentMission.guiMenue.master.isPullDownOpen()	
	local isGenerate, errorTxt = true, "";
	function printError()
		if not isGenerate and string.len(tostring(errorTxt)) > 0 then print(tostring(errorTxt));end;
	end;	
	local whichSubPDA = whichPDA or "masterPDA_"
	local lineButtonTable = {};
	local lineCmdTable = {};
	--line 1
	lineButtonTable[#lineButtonTable+1] = {
		returnClick = "pdaAutoClose_";
		isHidden = false; 
		buttonType = 5; 
		buttonWidth = 0; 		
		txtOverButton = "Auto Close PDA"; 
		helpIcon = 0; 
		helpTxt = {"Is new PDA open then autoclose this PDA\nonly for PDA"};
		infoTxt = "Is new PDA open then autoclose this PDA";
		cmdTable = moSetGetOverlays.pda[whichSubPDA];
		cmdValue = "autoClose";
		cmdType = "boolean";
		buttonTxt = "";		
	};
	lineButtonTable[#lineButtonTable+1] = {
		returnClick = "pdaAutoOpenCloseSelectSettings_";
		isHidden = false; 
		buttonType = 5; 
		buttonWidth = 0; 		
		txtOverButton = "Auto Open/Close Settings"; 
		helpIcon = 0; 
		helpTxt = {"Is Select Settings PDA then autoOpen/Close this PDA\nonly for Settings PDA"};
		infoTxt = "Is Select Settings PDA then autoOpen/Close this PDA";
		cmdTable = moSetGetOverlays.pda[whichSubPDA];
		cmdValue = "autoOpenCloseSelectSettings";
		cmdType = "boolean";
		buttonTxt = "";	
	};	
	isGenerate, errorTxt = g_currentMission.guiMenue.guiSetGetMenue:generateModMenuePageSideLine( {modMenueTable=installModGuiTablePos, masterPage=masterPage, slavePage=slavePage, pageSide=pageSide, line=1, maxButtons=2, isHidden=false, lineButtonTable=lineButtonTable} );
	printError();	
	--line 1	
	
	--line 2
	lineButtonTable = {};
	lineButtonTable[#lineButtonTable+1] = {
		returnClick = "pdaAutoPosXmiddle_";
		isHidden = false; 
		buttonType = 5; 
		buttonWidth = 0; 		
		txtOverButton = "Auto Pos (Reset)"; 
		helpIcon = 0; 
		helpTxt = {""};
		infoTxt = "Centered PDA Position XY (AppIcons length)";
		cmdTable = moSetGetOverlays.pda[whichSubPDA]; 
		cmdValue = "autoPosMiddle";
		cmdType = "boolean";
		buttonTxt = "";	
	};
	lineButtonTable[#lineButtonTable+1] = {
		returnClick = "pdaAppIconOpenMarker_";
		isHidden = false; 
		buttonType = 7; 
		buttonWidth = 0; 		
		txtOverButton = "App Icon Marker";		
		txtOverButtonColor = moColors.intern["green"];
		helpIcon = 0; 
		helpTxt = {};
		infoTxt = "Set Optional App Marker\nfor a under PDA or ...\nno color or ... function";
		cmdTable = moSetGetOverlays.pda[whichSubPDA].line[1].app[1]; 
		cmdValue = "openMarker";
		cmdType = "boolean";
		buttonTxt = "";
	};
	if test then --deaktiviert
	lineButtonTable[#lineButtonTable+1] = {
		returnClick = "pdaAutoHidden_";
		isHidden = false; 
		buttonType = 5; 
		buttonWidth = 0; 		
		txtOverButton = "Auto Hidden"; 
		helpIcon = 1; 
		helpTxt = {"Is Warning or ... ON and Info present then see Small PDA with Info"};
		infoTxt = "Set PDA Auto Hidden is hiddenTimer end, close Settings Menue for Test";
		cmdTable = moSetGetOverlays.pda[whichSubPDA].hidden; 
		cmdValue = "auto";
		cmdType = "boolean";
		buttonTxt = "";	
	};
	lineButtonTable[#lineButtonTable+1] = {
		returnClick = "pdaHiddenTimer_";
		isHidden = false; 
		buttonType = 3; 
		buttonWidth = 0; 		
		txtOverButton = "Hidden Timer"; 
		helpIcon = 0; 
		helpTxt = {""};
		infoTxt = "Set PDA Hidden is hiddenTimer end and Auto Hidden ON, close Settings Menue for Test\n1 Sec,2 Sec etc. (max 60 sec.)";
		cmdTable = moSetGetOverlays.pda[whichSubPDA].hidden; 
		cmdValue = "timer";
		cmdType = "int";
		buttonTxt = "";	
	};
	end;	
	isGenerate, errorTxt = g_currentMission.guiMenue.guiSetGetMenue:generateModMenuePageSideLine( {modMenueTable=installModGuiTablePos, masterPage=masterPage, slavePage=slavePage, pageSide=pageSide, line=2, maxButtons=2, isHidden=false, lineButtonTable=lineButtonTable} );
	printError();
	--line 2	
	
	--line 3 
	lineButtonTable = {};
	lineButtonTable[#lineButtonTable+1] = {
		returnClick = "iconPreviewStart_";
		isHidden = false; 
		buttonType = 7; 
		buttonWidth = 0; 		
		txtOverButton = "Preview Icons"; 
		txtOverButtonColor = moColors.intern["green"];
		helpIcon = 1; 
		helpTxt = {"View IconType and Icon App Tip (if available)"};
		infoTxt = "See all Preview Icons\nselect icon with left click\nclick right at PDA/App for insert/replace this Icon";
		cmdTable = moSetGetOverlays.iconPreviewPDA;
		changeAlone = nil; --GuiMenue set new/changes Select or Mod alone set new/changes select then set true (default false or nil)
		cmdValue = "isOpen";
		cmdType = "boolean";		
		buttonTxt = "Preview PDA On/Off";
	};
	lineButtonTable[#lineButtonTable+1] = {
		returnClick = "pdaAppIconDelete_";
		isHidden = false; 
		buttonType = 8; 
		buttonWidth = 0; 		
		txtOverButton = "Delete App Icon"; 
		txtOverButtonColor = moColors.intern["orangeRed"];
		helpIcon = 0; 
		helpTxt = {""};
		infoTxt = "Delete select App Icon\nhas no influence on the cmd";
		cmdTable = nil;
		changeAlone = nil; --GuiMenue set new/changes Select or Mod alone set new/changes select then set true (default false or nil)
		cmdValue = nil;
		cmdType = "stringOnly";		
		buttonTxt = "Delete Select Icon";
	};
	isGenerate, errorTxt = g_currentMission.guiMenue.guiSetGetMenue:generateModMenuePageSideLine( {modMenueTable=installModGuiTablePos, masterPage=masterPage, slavePage=slavePage, pageSide=pageSide, line=3, maxButtons=2, isHidden=false, lineButtonTable=lineButtonTable} );
	printError();	
	--line 3 
	
	--line 4
	lineButtonTable = {};	
	lineButtonTable[#lineButtonTable+1] = {
		returnClick = "pdaAppIconTextEdit_";
		isHidden = false; 
		buttonType = 8; 
		buttonWidth = -1; 		
		txtOverButton = "Icon";		
		txtOverButtonColor = moColors.intern["green"];
		helpIcon = 0; 
		helpTxt = {};
		infoTxt = "Edit Text for Icon (only for Icon Typ 4)\nis Test and not for large Text\nbest 4 and 4 (also Text Text)";
		cmdTable = nil; 
		cmdValue = nil;
		cmdType = "stringOnly";
		buttonTxt = "Text";
	};
	lineButtonTable[#lineButtonTable+1] = {
		returnClick = "pdaAppIconTextSize_";
		isHidden = false; 
		buttonType = 3; 
		buttonWidth = -1; 		
		txtOverButton = "Size";		
		txtOverButtonColor = moColors.intern["green"];
		helpIcon = 0; 
		helpTxt = {};
		infoTxt = "Set Size for Text Icon (only for Icon Typ 4)\nis Test and not for large Text\nbest 4 and 4 (also Text Text)";
		cmdTable = nil; 
		cmdValue = nil;
		cmdType = "stringOnly";
		buttonTxt = "Size";
	};
	lineCmdTable = {};
	local index = 1;	
	for name, _ in pairs(moColors.extern) do		
		lineCmdTable[index] = {};
		lineCmdTable[index].cmdTable = nil;
		lineCmdTable[index].cmdValue = nil;
		lineCmdTable[index].cmdType = "stringOnly";
		lineCmdTable[index].buttonTxt = tostring(name);
		lineCmdTable[index].isSelect = index == 1;
		index = index+1;
	end;
	local keys = {};
	local newSortTable = {};
	function sortTable(myTable)			
		for key, _ in pairs(myTable) do
			table.insert(keys, key);
		end
		table.sort(keys, function(keyLhs, keyRhs) return myTable[keyLhs].buttonTxt < myTable[keyRhs].buttonTxt end);
		for _, key in ipairs(keys) do
			table.insert(newSortTable, myTable[key]);
		end;
	end;
	sortTable(lineCmdTable);		
	lineCmdTable = newSortTable;	
	lineButtonTable[#lineButtonTable+1] = {
		returnClick = "pdaAppIconTextColor_";
		isHidden = false; 
		buttonType = 2; 
		buttonWidth = 0; 		
		txtOverButton = "TextColor";		
		txtOverButtonColor = moColors.intern["green"];
		helpIcon = 0; 
		helpTxt = {};
		infoTxt = "Text Color for Icon (only for Icon Typ 4)\nloading over colors.xml\noptional insert new color";
		cmdTable = lineCmdTable; 
		cmdValue = nil;
		cmdType = "pullDown_1";
		buttonTxt = "";
	};
	isGenerate, errorTxt = g_currentMission.guiMenue.guiSetGetMenue:generateModMenuePageSideLine( {modMenueTable=installModGuiTablePos, masterPage=masterPage, slavePage=slavePage, pageSide=pageSide, line=4, maxButtons=3, isHidden=false, lineButtonTable=lineButtonTable, buttonAutoWidth=false} );
	printError();
	--line 4
	
	--line 5
	lineButtonTable = {};
	lineButtonTable[#lineButtonTable+1] = {
		returnClick = "newPdaLine_";
		isHidden = false; 
		buttonType = 8; 
		buttonWidth = 0; 		
		txtOverButton = "Generate New PDA Line"; 
		helpIcon = 1; 
		helpTxt = {"For Delete a Line, see/click Line Settings\nCan not delete MasterLine 1"};
		infoTxt = "Set a new Line at Select PDA under Select PDA Line";
		cmdTable = nil; 
		cmdValue = nil;
		cmdType = "stringOnly";
		buttonTxt = "PDA Lines Total(".. tostring(#moSetGetOverlays.pda[whichSubPDA].line).. ")";	
	};
	lineButtonTable[#lineButtonTable+1] = {
		returnClick = "newPdaLineApp_";
		isHidden = false; 
		buttonType = 8; 
		buttonWidth = 0; 		
		txtOverButton = "Generate New App at Line"; 
		helpIcon = 1; 
		helpTxt = {"For Delete a App, see/App Settings"};
		infoTxt = "Set a new App(empty) at Select App (to the right)";
		cmdTable = nil; 
		cmdValue = nil;
		cmdType = "stringOnly";
		buttonTxt = "PDA Line Apps Total(".. tostring(moSetGetOverlays.pda[whichSubPDA].line[1].appsAtLine).. ")";	
	};
	isGenerate, errorTxt = g_currentMission.guiMenue.guiSetGetMenue:generateModMenuePageSideLine( {modMenueTable=installModGuiTablePos, masterPage=masterPage, slavePage=slavePage, pageSide=pageSide, line=5, maxButtons=2, isHidden=false, lineButtonTable=lineButtonTable} );
	printError();
	--line 5
	
	--line 6
	lineButtonTable = {};	
	lineButtonTable[#lineButtonTable+1] = {
		returnClick = "deletePdaLine_";
		isHidden = false; 
		buttonType = 8; 
		buttonWidth = 0; 		
		txtOverButton = "Delete PDA Line"; 
		txtOverButtonColor = moColors.intern["orangeRed"];
		helpIcon = 1; 
		helpTxt = {"!! Warning !! Delete line is irrevocable, with(incl.) all Apps Settings.\nlast PDA Line can not be deleted\nDelete PDA"};
		infoTxt = "Delete a Line at PDA (incl. all Apps)";
		cmdTable = nil; 
		cmdValue = nil;
		cmdType = "stringOnly";
		buttonTxt = "Delete Select Line (1)";	
	};		
	lineButtonTable[#lineButtonTable+1] = {
		returnClick = "deletePdaLineApp_";
		isHidden = false; 
		buttonType = 8; 
		buttonWidth = 0; 		
		txtOverButton = "Delete App at Line"; 
		txtOverButtonColor = moColors.intern["orangeRed"];
		helpIcon = 1; 
		helpTxt = {"!! Warning !! Delete Pos(App) is irrevocable, with(incl.) all App Settings."};
		infoTxt = "Delete a Pos(App) at PDA Line";
		cmdTable = nil; 
		cmdValue = nil;
		cmdType = "stringOnly";
		buttonTxt = "Delete Select App (1)";
	};	
	isGenerate, errorTxt = g_currentMission.guiMenue.guiSetGetMenue:generateModMenuePageSideLine( {modMenueTable=installModGuiTablePos, masterPage=masterPage, slavePage=slavePage, pageSide=pageSide, line=6, maxButtons=2, isHidden=false, lineButtonTable=lineButtonTable} );
	printError();
	--line 6
	
	--line 7
	lineButtonTable = {};	
	lineButtonTable[#lineButtonTable+1] = {
		returnClick = "deleteTabletPda_";
		isHidden = false; 
		buttonType = 8; 
		buttonWidth = 0; 		
		txtOverButton = "Delete This Tablet PDA"; 
		txtOverButtonColor = moColors.intern["orangeRed"];
		helpIcon = 1; 
		helpTxt = {"Activate Backup ... XML to safety\nand/or Safety delete confirm (your decision)\nis Delete ... empty then need not confirm"};
		infoTxt = "!! Warning !! Delete Tablet PDA is irrevocable, with(incl.) all Line/Apps Settings.";
		cmdTable = nil;
		changeAlone = nil; --GuiMenue set new/changes Select or Mod alone set new/changes select then set true (default false or nil)
		cmdValue = nil;
		cmdType = "stringOnly";		
		buttonTxt = tostring(moSetGetOverlays.pda[whichSubPDA].name);
	};	
	isGenerate, errorTxt = g_currentMission.guiMenue.guiSetGetMenue:generateModMenuePageSideLine( {modMenueTable=installModGuiTablePos, masterPage=masterPage, slavePage=slavePage, pageSide=pageSide, line=7, maxButtons=2, isHidden=false, lineButtonTable=lineButtonTable, buttonAutoWidth=true} );
	printError();
	--line 7
	
end;

local test=false;
function tabletPdaDefaultSide1:setReturnClick(self, returnClick, whichPDA, isPullDownOpen, clickLine, clickButton, masterPage, slavePage, pageSide, isVirtualReturnClick) --byName (virtual.... for Activate over Mod(not over Gui Menue click)for set Icons or at GuiMenue or or etc)
	local whichSubPDA = whichPDA or "masterPDA_";
	local upOrLeft = string.find(returnClick, "_Up") or string.find(returnClick, "_Left");
	local downOrRight = string.find(returnClick, "_Down") or string.find(returnClick, "_Right");
	
	local defaultPageSide = 1; --ändern wenn die seite verschoben wird
	
	if string.find(returnClick, "pdaAutoClose_") then
		if moSetGetOverlays.pda[whichSubPDA].autoClose then moSetGetOverlays.pda[whichSubPDA].autoClose = false;else moSetGetOverlays.pda[whichSubPDA].autoClose = true;end;return;
	elseif string.find(returnClick, "pdaAutoOpenCloseSelectSettings_") then
		if moSetGetOverlays.pda[whichSubPDA].autoOpenCloseSelectSettings then moSetGetOverlays.pda[whichSubPDA].autoOpenCloseSelectSettings = false;else moSetGetOverlays.pda[whichSubPDA].autoOpenCloseSelectSettings = true;end;return;
	elseif string.find(returnClick, "pdaAutoPosXmiddle_") then
		if moSetGetOverlays.pda[whichSubPDA].autoPosMiddle then moSetGetOverlays.pda[whichSubPDA].autoPosMiddle = false;else moSetGetOverlays.pda[whichSubPDA].autoPosMiddle = true;end;moSetGetOverlays:replacePdaPosXY(self, whichSubPDA);return;
	elseif string.find(returnClick, "iconPreviewStart_") then		
		if moSetGetOverlays.iconPreviewPDA.isOpen then moSetGetOverlays.iconPreviewPDA.isOpen = false;moSetGetOverlays.iconPreviewPDA.bounds[1] = 1;moSetGetOverlays.iconPreviewPDA.bounds[2] = 150;moSetGetOverlays.iconPreviewPDA.bounds[3] = 1;return;end;
		moSetGetOverlays.iconPreviewPDA.isOpen = true;		
	elseif string.find(returnClick, "pdaAppIconDelete_") then
		local selectLine = moSetGetMohPDA:getLineMouseSelect(whichSubPDA);
		local isSelect, selectApp = moSetGetMohPDA:getAppMouseSelect(selectLine, whichSubPDA);
		if isSelect then
			moSetGetOverlays.pda[whichSubPDA].line[selectLine].app[selectApp].iconTyp = 0;moSetGetOverlays.pda[whichSubPDA].line[selectLine].app[selectApp].iconName = "mohIconBlank_";			 
			moSetGetOverlays:loadAppIconsOverlays(self, moSetGetOverlays.pda[whichSubPDA].line[selectLine].app[selectApp].iconName, moSetGetOverlays.pda[whichSubPDA].line[selectLine].app[selectApp].iconTyp, nil, nil, whichSubPDA);
			g_currentMission.guiMenue.modTable[MultiOverlayV3.guiMenue.modTable].tempSave = true;
		end;
		return ;
	elseif string.find(returnClick, "pdaAppIconOpenMarker_") then
		local selectLine = moSetGetMohPDA:getLineMouseSelect(whichSubPDA);
		local isSelect, selectApp = moSetGetMohPDA:getAppMouseSelect(selectLine, whichSubPDA);
		if isSelect then
			if moSetGetOverlays.pda[whichSubPDA].line[selectLine].app[selectApp].openMarker then moSetGetOverlays.pda[whichSubPDA].line[selectLine].app[selectApp].openMarker = false;else moSetGetOverlays.pda[whichSubPDA].line[selectLine].app[selectApp].openMarker = true;end;
		end;
		return;
	elseif string.find(returnClick, "pdaAppIconTextEdit_") then
		local selectLine = moSetGetMohPDA:getLineMouseSelect(whichSubPDA);
		local isSelect, selectApp = moSetGetMohPDA:getAppMouseSelect(selectLine, whichSubPDA);
		if isSelect then
			if moSetGetOverlays.pda[whichSubPDA].line[selectLine].app[selectApp].iconTyp == 4 then
				local iconName = moSetGetOverlays.pda[whichSubPDA].line[selectLine].app[selectApp].iconName;
				if moSetGetOverlays.appIcon[whichSubPDA][iconName].typTable ~= nil and moSetGetOverlays.appIcon[whichSubPDA][iconName].typTable["typ4"] ~= nil then
					moSetGetMohPDA:editIconText(whichPDA, iconName);
				end;
			else
				g_currentMission:showBlinkingWarning("Select first Text App Icon (Typ4)", 2000);
			end;
		end;
		return;
	elseif string.find(returnClick, "pdaAppIconTextSize_") then
		local selectLine = moSetGetMohPDA:getLineMouseSelect(whichSubPDA);
		local isSelect, selectApp = moSetGetMohPDA:getAppMouseSelect(selectLine, whichSubPDA);
		if isSelect then
			local maxSize = 0.015;minSize = 0.007;sizeLevel = 0.0005;
			if moSetGetOverlays.pda[whichSubPDA].line[selectLine].app[selectApp].iconTyp == 4 then
				local iconName = moSetGetOverlays.pda[whichSubPDA].line[selectLine].app[selectApp].iconName;
				if moSetGetOverlays.appIcon[whichSubPDA][iconName].typTable ~= nil and moSetGetOverlays.appIcon[whichSubPDA][iconName].typTable["typ4"] ~= nil and moSetGetOverlays.appIcon[whichSubPDA][iconName].typTable["typ4"].size ~= nil then
					if upOrLeft then
						if moSetGetOverlays.appIcon[whichSubPDA][iconName].typTable["typ4"].size+sizeLevel > maxSize then g_currentMission:showBlinkingWarning("Is maxLevel", 2000);return;end;
						moSetGetOverlays.appIcon[whichSubPDA][iconName].typTable["typ4"].size = moSetGetOverlays.appIcon[whichSubPDA][iconName].typTable["typ4"].size+sizeLevel;
					elseif downOrRight then	
						if moSetGetOverlays.appIcon[whichSubPDA][iconName].typTable["typ4"].size-sizeLevel < minSize then g_currentMission:showBlinkingWarning("Is minLevel", 2000);return;end;
						moSetGetOverlays.appIcon[whichSubPDA][iconName].typTable["typ4"].size = moSetGetOverlays.appIcon[whichSubPDA][iconName].typTable["typ4"].size-sizeLevel;
					end;
				end;
			else
				g_currentMission:showBlinkingWarning("Select first Text App Icon (Typ4)", 2000);
			end;
		end;
		return;
	elseif string.find(returnClick, "pdaAppIconTextColor_") and not isPullDownOpen then
		local getThisButtonPage = g_currentMission.guiMenue.guiSetGet:getButtonInfo( {modMenueTable=MultiOverlayV3.guiMenue.modTable, pageSide=defaultPageSide, name="pdaAppIconTextColor_"} );			
		if getThisButtonPage == nil then return;end;
		local guiPageTable = g_currentMission.guiMenue.modTable[MultiOverlayV3.guiMenue.modTable].page[getThisButtonPage.masterPage].side[getThisButtonPage.pageSide];
		if getThisButtonPage.slavePage ~= nil then guiPageTable = g_currentMission.guiMenue.modTable[MultiOverlayV3.guiMenue.modTable].page[getThisButtonPage.masterPage].page[getThisButtonPage.slavePage].side[getThisButtonPage.pageSide];end;
		local buttonTable = Utils.getNoNil(guiPageTable.line[getThisButtonPage.line].button[getThisButtonPage.button], nil);
		local selectLine = moSetGetMohPDA:getLineMouseSelect(whichSubPDA);
		local isSelect, selectApp = moSetGetMohPDA:getAppMouseSelect(selectLine, whichSubPDA);
		if isSelect and buttonTable ~= nil then
			if moSetGetOverlays.pda[whichSubPDA].line[selectLine].app[selectApp].iconTyp == 4 then
				local iconName = moSetGetOverlays.pda[whichSubPDA].line[selectLine].app[selectApp].iconName;
				if moSetGetOverlays.appIcon[whichSubPDA][iconName].typTable ~= nil and moSetGetOverlays.appIcon[whichSubPDA][iconName].typTable["typ4"] ~= nil then
					local pullDownSelect = moSetGetGuiMenue:getSelectPullDownLine(self, nil, nil, buttonTable);					
					moSetGetOverlays.appIcon[whichSubPDA][iconName].typTable["typ4"].color = buttonTable.cmdTable[pullDownSelect].buttonTxt;
					g_currentMission.guiMenue.modTable[MultiOverlayV3.guiMenue.modTable].tempSave = true;
				end;
			else
				g_currentMission:showBlinkingWarning("Select first Text App Icon (Typ4)", 2000);
			end;
		end;
	---double returnClick name (pro PDA),search before with ...getButtonInfo	
	elseif string.find(returnClick, "newPdaLine_") then		
		local getThisButtonPage = g_currentMission.guiMenue.guiSetGet:getButtonInfo( {modMenueTable=MultiOverlayV3.guiMenue.modTable, pageSide=defaultPageSide, name="newPdaLine_", pageGlobalName=whichSubPDA} );
		if getThisButtonPage == nil then return;end;		
		local selectLine = moSetGetMohPDA:getLineMouseSelect(whichSubPDA); 
		if moSetGetMohPDA:setLine(self, selectLine, nil, nil, true, nil, whichSubPDA) then--newLine			
			g_currentMission:showBlinkingWarning("Created New Line", 2000);				
			moSetGetMohPDA:resetRenderViewLines(whichSubPDA);				
			moSetGetGuiMenue:setAppMouseSelectButtoTxt(whichSubPDA, true, true, true, true); --(whichPDA, deletePdaLine, deletePdaLineApp, newPdaLine, newPdaLineApp)
		else
			g_currentMission:showBlinkingWarning("! UNKNOWN ERROR ! NOT Created New Line", 2000);
		end;							
		return;	
	elseif string.find(returnClick, "deletePdaLine_") then
		local getThisButtonPage = g_currentMission.guiMenue.guiSetGet:getButtonInfo( {modMenueTable=MultiOverlayV3.guiMenue.modTable,  pageSide=defaultPageSide, name="deletePdaLine_", pageGlobalName=whichSubPDA} );
		if getThisButtonPage == nil then return;end;		
		local selectLine = moSetGetMohPDA:getLineMouseSelect(whichSubPDA);
		if #moSetGetOverlays.pda[whichSubPDA].line == 1 then g_currentMission:showBlinkingWarning("This Line (1) can not be deleted\nDelete this PDA", 2000);return;end;				
		local isEmpty = moConfirm:isEmpty(whichSubPDA, nil, "tabletLine", selectLine, nil);				
		deleteCoroutineByWhat = coroutine.create(moConfirm.deleteTabletPdaByWhat);							
		coroutine.resume(deleteCoroutineByWhat, "tabletLine", whichSubPDA, selectLine);		
		if moGeneralSettings.deleteConfirm and not isEmpty then				
			g_currentMission.guiMenue.guiSetGet:openLsOrGuiMenueDialog("LsYesNoDialog", {onCloseCallback=moConfirm.deleteTabletPdaLine , dialogTitel=tostring(MultiOverlayV3.metadata.title), dialogText1="Is Not Empty\n! Delete Line ".. tostring(selectLine).. " in ".. tostring(moSetGetOverlays.pda[whichSubPDA].name).. " !\nDelete Line is irrevocable, with(incl.) all Apps Settings"})
			return;
		else
			moConfirm.deleteTabletPdaLine(true);
		end;				
		return;
	elseif string.find(returnClick, "newPdaLineApp_") then
		local getThisButtonPage = g_currentMission.guiMenue.guiSetGet:getButtonInfo( {modMenueTable=MultiOverlayV3.guiMenue.modTable, pageSide=defaultPageSide, name="newPdaLineApp_", pageGlobalName=whichSubPDA} );
		if getThisButtonPage == nil then return;end;		
		local selectLine = moSetGetMohPDA:getLineMouseSelect(whichSubPDA);
		local isSelect, selectApp = moSetGetMohPDA:getAppMouseSelect(selectLine, whichSubPDA);
		local appsAtLine = 0;
		if isSelect then			
			moSetGetMohPDA:setAppAtLine(self, selectLine, selectApp, nil, nil, true, nil, whichSubPDA);			
			moSetGetGuiMenue:setAppMouseSelectButtoTxt(whichSubPDA, false, true, false, true); --(whichPDA, deletePdaLine, deletePdaLineApp, newPdaLine, newPdaLineApp)
			g_currentMission.hud:showInGameMessage(tostring(MultiOverlayV3.metadata.title).. " Help Text", "Created New Empty App in Line ".. tostring(selectLine).. " Position ".. tostring(selectApp), 0);
		else
			g_currentMission:showBlinkingWarning("! UNKNOWN ERROR ! NOT Created New Empty App in Position", 2000);
		end;
		return;
	elseif string.find(returnClick, "deletePdaLineApp_") then		
		local getThisButtonPage = g_currentMission.guiMenue.guiSetGet:getButtonInfo( {modMenueTable=MultiOverlayV3.guiMenue.modTable, pageSide=defaultPageSide, name="deletePdaLineApp_", pageGlobalName=whichSubPDA} );
		if getThisButtonPage == nil then return;end;		
		local selectLine = moSetGetMohPDA:getLineMouseSelect(whichSubPDA); --moSetGetGuiMenue:getSelectPullDownLine(self, nil, nil, buttonTable);
		local isSelect, selectApp = moSetGetMohPDA:getAppMouseSelect(selectLine, whichSubPDA);
		if isSelect then
			if moSetGetOverlays.pda[whichSubPDA].line[selectLine].appsAtLine == 1 then g_currentMission:showBlinkingWarning("This App (1) can not be deleted\nDelete this Line", 2000);return;end;
			local isEmpty = moConfirm:isEmpty(whichSubPDA, nil, "tabletApp", selectLine, selectApp);
			deleteCoroutineByWhat = coroutine.create(moConfirm.deleteTabletPdaByWhat);							
			coroutine.resume(deleteCoroutineByWhat, "tabletApp", whichSubPDA, selectLine, selectApp); -- guiPageTable);	
			if moGeneralSettings.deleteConfirm and not isEmpty then	
				g_currentMission.guiMenue.guiSetGet:openLsOrGuiMenueDialog("LsYesNoDialog", {onCloseCallback=moConfirm.deleteTabletPdaApp , dialogTitel=tostring(MultiOverlayV3.metadata.title), dialogText1="Is Not Empty\n! Delete App ".. tostring(selectApp).. " in ".. tostring(moSetGetOverlays.pda[whichSubPDA].name).. " (Line ".. tostring(selectLine).. ") !\nDelete App is irrevocable, with(incl.) all Apps Settings"})
				return;
			else
				moConfirm.deleteTabletPdaApp(true);
			end;			
		else
			g_currentMission:showBlinkingWarning("! UNKNOWN ERROR ! NOT Delete this App in Position", 2000);
		end;
		return;
	elseif string.find(returnClick, "deleteTabletPda_") then 	
		if whichSubPDA == "masterPDA_" then g_currentMission:showBlinkingWarning("This Master PDA can not be deleted", 2000);return;end;
		local getThisButtonPage = g_currentMission.guiMenue.guiSetGet:getButtonInfo( {modMenueTable=MultiOverlayV3.guiMenue.modTable,  pageSide=defaultPageSide, name="deleteTabletPda_"} );
		if getThisButtonPage == nil then return;end;
		local guiPageTable = g_currentMission.guiMenue.modTable[MultiOverlayV3.guiMenue.modTable].page[getThisButtonPage.masterPage].side[getThisButtonPage.pageSide];
		if getThisButtonPage.slavePage ~= nil then guiPageTable = g_currentMission.guiMenue.modTable[MultiOverlayV3.guiMenue.modTable].page[getThisButtonPage.masterPage].page[getThisButtonPage.slavePage].side[getThisButtonPage.pageSide];end;							
		if moSetGetOverlays.pda[whichSubPDA] == nil then g_currentMission:showBlinkingWarning("This -".. tostring(whichSubPDA).. "- PDA Name not found or incorrect !", 2000);return;end;		
		local isEmpty = moConfirm:isEmpty(whichSubPDA, nil, "tabletPda");
		deleteCoroutineByWhat = coroutine.create(moConfirm.deleteTabletPdaByWhat);	
		coroutine.resume(deleteCoroutineByWhat, "tabletPda", whichSubPDA);
		if moGeneralSettings.deleteConfirm and not isEmpty then	
			g_currentMission.guiMenue.guiSetGet:openLsOrGuiMenueDialog("LsYesNoDialog", {onCloseCallback=moConfirm.deleteTabletPda , dialogTitel=tostring(MultiOverlayV3.metadata.title), dialogText1="Is Not Empty\n! Delete Tablet PDA ".. tostring(moSetGetOverlays.pda[whichSubPDA].name).. " !\nDelete Tablet PDA is irrevocable, with(incl.) all Line/Apps Settings."})
			return;
		else
			moConfirm.deleteTabletPda(true);
		end;		
	end;
	return;
end;