moItemsConfig = {};

function moItemsConfig:onStartMission()
	moItems:loadItems();
end;

function moItemsConfig:defaultValues()
	moItems.values = {items={}, updateTimer=10, msec=false}
end;

function moItemsConfig:loadXml(self, Xml, xmlNameTag, file, isSaveGameIndex)
	if moItems.values == nil then moItemsConfig:defaultValues();end;
	local groupNameTag = (xmlNameTag.. ".module.items(%d)"):format(0);
	if getXMLBool(Xml, groupNameTag.. "#mSecTimer") ~= nil then
		moItems.values.msec = getXMLBool(Xml, groupNameTag.. "#mSecTimer");
	end;
	if getXMLInt(Xml, groupNameTag.. "#updateTimer") then
		moItems.values.updateTimer = getXMLInt(Xml, groupNameTag.. "#updateTimer");
	end;	
end;

function moItemsConfig:saveXml(self, Xml, xmlNameTag)
	if moItems.values == nil then moItemsConfig:defaultValues();end;
	----------------------------------------------------------------------------------------------
	local groupNameTag = (xmlNameTag.. ".module.items(%d)"):format(0);
	setXMLInt(Xml, groupNameTag.. "#updateTimer", moItems.values.updateTimer);
	setXMLBool(Xml, groupNameTag.. "#mSecTimer", moItems.values.msec);
	----------------------------------------------------------------------------------------------	
end;

function moItemsConfig.onSaveCallback()
	moSetGetClientSettings:saveConfig(self);
end;